/*
 * Copyright (c) "Neo4j"
 * Neo4j Sweden AB [http://neo4j.com]
 *
 * This file is part of Neo4j.
 *
 * Neo4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import _includes from "lodash.includes";
import * as CompletionTypes from "../CompletionTypes";
import CypherKeywords from "../../lang/CypherKeywords";

// If any of the keywords contains element text, return ALL
export default (element => {
  const text = element.getText().toLowerCase();
  if (CypherKeywords.find(keyword => _includes(keyword.toLowerCase(), text))) {
    return CompletionTypes.ALL;
  }
  return [];
});